#ifndef _HASSOL_HPP_
#define _HASSOL_HPP_

int dbg_sol=0;

rat_t sol_prec=rat_t(1)/1024;

bool hassol0(const vector<inter_t> &va,const cp_t &cl,vector<double> &vrl)
{
  if(dbg_sol>1) printf("HS0\n");

  rat_t prec=sol_prec;

  vector<rat_t> sinmi(5),sinma(5);
  vector<rat_t> cosmi(5),cosma(5);
  for(int i=0;i<5;i++) {
    auto in=isincospi(va[i],prec);
    sinmi[i]=in.first.a;
    sinma[i]=-in.first.b;
    cosmi[i]=in.second.a;
    cosma[i]=-in.second.b;
    if(dbg_sol) printf("(%d) sin: r=%lf %lf .. %lf d=%lf   cos: r=%lf %lf .. %lf d=%lf\n",i,sin(getd(va[i].mid())*M_PI),getd(sinmi[i]),getd(sinma[i]),getd(-sinmi[i]-sinma[i]),cos(getd(va[i].mid())*M_PI),getd(cosmi[i]),getd(cosma[i]),getd(-cosmi[i]-cosma[i]));
  }

  auto cl2=cl;

  cl2.cut(sinmi,0);
  cl2.cut(sinma,0);
  cl2.cut(cosmi,0);
  cl2.cut(cosma,0);
  if(dbg_sol>1) {cout<<"hs0 : apres cut sin et cos:\n";cl2.affd();}

  if(cl2.empty()) {
    if(dbg_sol>1) printf("\\HS0 : 0\n");
    return 0;
  }

  //while(desc(cl2,rat_t(1)/1024));

  auto s=cl2.extr();
  assert(!s.empty());
  auto v=*(s.begin());
  vrl.resize(5);
  for(int i=0;i<5;i++)
    vrl[i]=getd(v[i]);

  if(dbg_sol>1) printf("\\HS0 : 1\n");
  return 1;

}

void proj(const ass_t &ca,const vector<inter_t> &vx,vector <inter_t> &vca)
{
  vca.resize(5);
  for(int i=0;i<5;i++) {
    vca[i]=inter_t((ca.o[i]));
    for(int j=0;j<ca.dim;j++)
      vca[i]=vca[i]+vx[j]*(ca.v[j][i]);
  }
}

bool testin(const ass_t &ca,const vector<inter_t> &vca,const rat_t &border=0)
{
  for(int i=0;i<5;i++)
    if(vca[i].b<border || vca[i].a>1-border) {
      //printf("out\n");
      return 0;
    }

  return 1;
}

bool hassolx(const ass_t &ca,const ass_t &sa,const vector<inter_t> &vx,const cp_t &cl,int pr,vector<double> &vra,vector<double> &vrl) //,vector<double> &vra,vector<double> &vrl,const rat_t &border,int pr=0)
{
  if(dbg_sol>1) printf("(%2d) HSX\n",pr);

  vector<inter_t> vca,va;
  proj(ca,vx,vca);
  proj(sa,vx,va);

  if(dbg_sol>2) for(int i=0;i<ca.dim;i++)printf("> %lf .. %lf\n",getd(vx[i].a),getd(vx[i].b));
  if(dbg_sol>2) for(int i=0;i<5;i++)printf("<a %lf .. %lf\n",getd(vca[i].a),getd(vca[i].b));
  if(dbg_sol>2) for(int i=0;i<5;i++)printf("<s %lf .. %lf\n",getd(va[i].a),getd(va[i].b));

  int r0=hassol0(va,cl,vrl);
  if(r0==0) {
    if(dbg_sol>1) printf("(%2d) \\HSX:0 r0\n",pr);
    return 0;
  }

  rat_t ma=-1;
  int d=-1;
  for(int j=0;j<sa.dim;j++)
    if(ma<vx[j].len()) ma=vx[d=j].len();

  rat_t prec=sol_prec;

  if(ma<prec) {
    vra.resize(5);
    for(int i=0;i<5;i++)
      vra[i]=getd(vca[i].a);

    if(dbg_sol>1) printf("(%2d) \\HSX:r0=%d\n",pr,r0);
    return 1;
  }

  vector<inter_t> vx2[2],vy[2];

  for(int i =0;i<2;i++)
    vx2[i]=vx;

  rat_t m=(vx[d].a+vx[d].b)/2;
  vx2[0][d].b=vx2[1][d].a=m;

  proj(ca,vx2[0],vy[0]);
  proj(ca,vx2[1],vy[1]);

  if(testin(ca,vy[0])==0) {
    if(testin(ca,vy[1])==0) {
      //warn("WTF IN!!!\n");
      return 0;
    } else
      return hassolx(ca,sa,vx2[1],cl,pr,vra,vrl);
  }

  int dd=0;

  int r1=hassolx(ca,sa,vx2[dd],cl,pr+1,vra,vrl);
  if(dbg_sol>1) printf("(%2d) HSX:r1=%d\n",pr,r1);
  if(r1) return 1;

  int r2=hassolx(ca,sa,vx2[1-dd],cl,pr+1,vra,vrl);
  if(dbg_sol>1) printf("(%2d) HSX:r2=%d\n",pr,r2);
  return r2;
}

bool hassol(const ass_t ca,const cp_t &cl,vector<double> &vra,vector<double> &vrl)
{
  if(dbg_sol) cout<<"hassol"<<endl;
  assert(ca.dim>=0);
  auto sa=ca;
  sa.sum();

  vector<inter_t> vx,vy;
  vx.resize(ca.dim);

  bool f=1;
  cpl_t cla(ca,1);
  for(auto &it:cla.s) {
    for(int i=0;i<ca.dim;i++)
      if(f)
	vx[i]=inter_t(it[i]);
      else
	vx[i].add(it[i]);
    f=0;
  }

  proj(ca,vx,vy);

  if(!testin(ca,vy)) return 0;

  return hassolx(ca,sa,vx,cl,0,vra,vrl);
}

#endif
