#include "u.hpp"

#include "ass.hpp"

void setalldbg(int dbg_all);

#include "tile.hpp"

int skippause=0;
int doaffstat=0;
int autonext=0;
long long nbrec=0,nbrec2=0;

#include "tile_disp.hpp"

void setalldbg(int dbg_all) {
  dbg_cp=dbg_all;
  dbg_cpan=dbg_all;
  dbg_sol=dbg_all;
  dbg_nt=dbg_all;
} //dbg_

int dbg_all=0;

vector<vvi_t> vr;

void readall() {
  char bf[10000];
  FILE *in=fopen("all.txt","r");
  assert(in);
  while(fgets(bf,9999,in)) {
    vvi_t a=readvvi(bf);
    vr.push_back(a);
  }
  fclose(in);
}

int maxpr=1000;

void comppoly() {
#ifdef CAIRO
  taff.comppos(aff_angle0);
#endif
}

void settaff(const t_t &t)
{
#ifdef CAIRO
  //if(mopt["inter"]==0) return;
  taff=t;
#endif
}

int pause(const string &info)
{
#ifdef CAIRO
  if(mopt["inter"]==0) return 0;
  if(info!="REC" && mopt["inter"]<2) return 0;
  if(skippause>0) {
    skippause--;
    return 0;
  }
  static int k=0,k2=0;
  char bf[100];
  snprintf(bf,99,"(%d) (%d) ",k2,k);
  k++;
  if(info=="REC") k2++;
  comppoly();
  cairo_aff(string(bf)+info);
  static int f=1;
  if(f==0 && (autonext<0 || autonext>k)) {
    handle_events(win,0);
    return 'B';
  }
  f=0;
  int r=handle_events(win);
  return r;
#endif
  return 0;
}

int pause2(const t_t &t,int r,const string &pos="")
{
#ifdef CAIRO
  if(mopt["inter"]==r) {
    settaff(t);
    return pause(pos);
  }
#endif
  return 0;
}

void rec(const t_t &t,int pr);

void rec2(const t_t &t,int pr)
{
  nbrec2++;
  if(dbg_nt) printf("rec2:\n");
  if(dbg_nt>1) t.cl3.aff();

  auto t2=t;
  pause2(t,2,"debut rec 2");

  for(auto &it:t2.mpo) {
    if(dbg_nt>1) {printf("rec2 : ");::aff(it.first);}

    if(it.second.done) {
      if(dbg_nt>1) printf("already done : %d %d %d\n",it.second.eg,it.second.l,it.second.g);
      continue;
    }

    if(dbg_nt>1) printf("cases: %d %d %d\n",it.second.eg,it.second.l,it.second.g);

    if(it.second.eg) {
      if(dbg_nt>1) printf("=\n");
      auto t3=t2;
      t3.mpo[it.first].done=1;
      t3.mpo[it.first].imp(1,0,0);
      if(t3.addeg(it.first))
	rec2(t3,pr);
    }

    if(it.second.l) {
      if(dbg_nt>1) printf("<\n");
      auto t3=t2;
      t3.mpo[it.first].done=1;
      t3.mpo[it.first].imp(0,1,0);
      if(t3.addl(it.first))
	rec2(t3,pr);
    }

    if(it.second.g) {
      if(dbg_nt>1) printf(">\n");
      auto t3=t2;
      t3.mpo[it.first].done=1;
      t3.mpo[it.first].imp(0,0,1);
      if(t3.addl(-it.first))
	rec2(t3,pr);
    }

    return;
  }

  int rx=t2.close();
  if(dbg_nt>1) printf("close: %d \n",rx);

  if(rx<0)
    pause2(t,2,"close(rec2) KO");

  if(rx>=0) {
    if(t2.testsol())
      return rec(t2,pr);
    else {
      if(dbg_nt>1) printf("rec2: testsol KO\n");
    }
  }
}

void rec(const t_t &t,int pr)
{
  nbrec++;

  {
    static map<ass_t,vi_t> m;
    vi_t v;
    auto it=m.find(t.cl3.c);
    if(it==m.end())
      m[t.cl3.c]=v=findvect(mainca,t.cl3.c);
    else v=it->second;
    if(v!=v0) {
      auto t2=t;
      if(!t2.addeg(v)) return;
      rec(t2,pr+1);
      return;
    }
  }

  if(dbg_nt) printf("rec pr=%d nbrec=%Ld \n",pr,nbrec);
  if(dbg_nt>1) t.cl3.aff();
    pause2(t,1,"REC");

  if(skipknown && isknownB(mainca,t.cl3.c)) {
    if(dbg_nt) printf("skip known type\n");
    return;
  }

  if(knowntoskip.size()>0) {
    auto rr=isknownB(mainca,t.cl3.c);
    for(auto &it:knowntoskip)
      if(rr&(1LL<<it) || rr&(1LL<<(it+32))) {
	if(dbg_nt) printf("skip known type %d\n",it);
	return;
      }
  }

  if(pr>=maxpr) {
    printf("MAXPR %d '%s'\n",pr,cmd.c_str());

#ifdef CAIRO
    settaff(t);
    comppoly();
    cairo_aff_pdf("maxpr");
#endif
    throw int(42);
  }

  int br=t.nexttobranch();

  if(dbg_nt) printf("branch on %d\n",br);

  vector<int> brv=t.getpointv(br);
  auto s2=t.poscote2(brv);
  assert(s2.size()!=0);

  for(auto &x:s2) {
    for(int dd=0;dd<2;dd++) {
      int tp[5];
      auto t2=t;
      t2.makepenta((dd==0)?1:-1,tp);

      int u1=t2.getunk(br);
      assert(t2.vhe[u1].angle==ANG_UNK);
      int u2=tp[(dd==0)?(4+x.angle)%5:(9-(x.angle))%5];

      if(!t2.makenext(t2.prev(u2),u1,x.a180?ANG_180:ANG_0))
	continue;

      pause2(t2,2,"avant close");

      int r=t2.close();

      if(r<0) {
	if(dbg_nt>1) printf("close : returns -1\n");
	pause2(t2,2,"apres close (-1)");
	continue;
      }

      rec2(t2,pr+1);

    }
  }

  if(dbg_nt)    cout<<"END REC\n";
}

int _main(const cp_t *cp=NULL) {
  t_t t;
  t.makepenta();
  if(cp)
    t.cl3=*cp;

#ifdef CAIRO
  if(cairo) g_init();
#endif

  try {
    printf("START\n");
    rec(t,0);
    printf("END FINITE '%s'\n",cmd.c_str());
  } catch (int e) {
    printf("ERROR catch %d\n",e);
  }

  printf("cmd: %s\n",cmd.c_str());
  printf("#rec=%Ld #rec2=%Ld\n",nbrec,nbrec2);

#ifdef CAIRO
  if(cairo) { // affiche
    comppoly();
    handle_events(win);
  }
#endif

  return 0;
}

void proc(const ass_t &a)
{
  setmainca(a);
  _main();
}

void proc(const ass_t &a,const ass_t *cl)
{
  setmainca(a);
  cp_t x(*cl,0);
  _main(&x);
}

int main(int ac, char **av)
{
  for(int i=0;i<ac;i++)
    cmd+=string(av[i])+" ";

  cout<<"cmd : "<<cmd<<endl;

  readopt(ac,av);

  int skipexcept=-1;
  setopt(nocut,"nocut");

  setopt(skipknown,"skipknown");
  setopt(skipexcept,"skipexcept");
  setopt(algobnd,"algobnd");
  setopt(maxpr,"maxpr");
#ifdef CAIRO
  setopt(cairo,"cairo");
#endif
  setopt(autonext,"autonext");

  setopt(dbg_all,"dbg");
  setopt(dbg_cp,"dbg_cp");
  setopt(dbg_cpan,"dbg_cpan");
  setopt(dbg_sol,"dbg_sol");
  setopt(dbg_nt,"dbg_nt");

  setopt(anprintpoly,"anprintpoly");

  if(dbg_all>=0) {
    if(dbg_cp<0) dbg_cp=dbg_all;
    if(dbg_cpan<0) dbg_cpan=dbg_all;
    if(dbg_sol<0) dbg_sol=dbg_all;
    if(dbg_nt<0) dbg_nt=dbg_all;
  } //dbg_

  if(skipexcept>=0) {
    for(int i=0;i<32;i++)
      if(i!=skipexcept)
	knowntoskip.insert(i);
  }

  usedopt.insert("inter");

  warnopt();

  readknowntypes();
  readall();
  assert(vr.size()==371);

  if(av[1][0]=='t' || av[1][0]=='T') {
    int i=atoi(av[1]+1);
    if(av[1][0]=='t')
      proc(knowna[i]);
    else
      proc(knowna[i],&knownl[i]);
  } else {
    vvi_t a=vr.at(atoi(av[1]));

    ass_t ca(5),cl(5);
    rat_t v[5];
    for(int i=0;i<5;i++)
      v[i]=1;
    ca.add(v,3);
    for(int i=0;i<a.size();i++) {
      for(int j=0;j<5;j++)
	v[j]=a[i][j];
      ca.add(v,2);
    }

    printf("ca.dim=%d\n",ca.dim);
    assert(ca.dim>=0);

    proc(ca);
  }

  return 0;
}
